//+------------------------------------------------------------------+
//|                                                     FX_Aimer.mq4 |
//|                                          Coded by Ronaldo Pontes |
//|                        Copyright  2009, GlobalSphere Consulting |
//|                            http://www.globalsphereconsulting.com |
//|                                 forex@globalsphereconsulting.com |
//|                                                                  |
//| Version History                                                  |
//| Ver 1.0  30/09/2009 added clock from: b-clock.mq4 by Nick Bilak  |
//+------------------------------------------------------------------+

#property copyright "Copyright  2009, GlobalSphere Consulting"
#property link      "http://www.globalsphereconsulting.com"

#property indicator_chart_window

extern bool Is5DigitBroker = false;
extern bool ShowAimBarTime = true;
extern bool ShowWindowBarTime = true;
extern bool ShowBarTimeComment = true;
extern bool ShowBarTimeHour = true;
extern bool ShowTickerLabel = true;
extern bool ShowTickerPrice = true;
extern bool ShowTickerSignal = true;
extern color BarTimeColor = White;
extern string AimAreaMode = "Pips";
extern int    AimPriceMode = 1;
extern string _AimPriceMode = "1-Bid, 2-Ask, 3-MidSpread (Bid+Ask)/2";
extern int AimArea1 = 10;
extern int AimArea2 = 20;
extern int AimArea3 = 30;
extern int AimArea4 = 50;
extern int AimArea5 = 80;
extern int AimArea6 = 130;
extern string AimBarTimeText = "FX_Aimer: ";
extern double   AimBarTimeV_Pos = 0;
extern double   AimBarTimeH_Pos = 46  ;
extern int   AimTickerSymbol = 4;
extern color AimTickerColor = Green;
extern double   AimTickerLabelH_Pos = -4;
extern double   AimTickerLabelV_Pos = 1.5;
extern double   AimBarH_Pos= 16;
extern color AimArea1Color = RoyalBlue;
extern color AimArea2Color = MediumPurple;
extern color AimArea3Color = HotPink;
extern color AimArea4Color = LightSkyBlue;
extern color AimArea5Color = LightPink;
extern color AimArea6Color = PapayaWhip;

string AimArea1Name = "AimArea1";
string AimArea2Name = "AimArea2";
string AimArea3Name = "AimArea3";
string AimArea4Name = "AimArea4";
string AimArea5Name = "AimArea5";
string AimArea6Name = "AimArea6";

double   _Point = 0;
double   priceMode = 0;
string   sPriceMode="Bid";

int AimPriceModeBkp=-1;

//---- buffers
// none

//+------------------------------------------------------------------+
//| Custom indicator de-initialization function                         |
//+------------------------------------------------------------------+

int deinit()
{


   ObjectDelete("BarTime");
   ObjectDelete("TimeLabel");
   unloadAimArea(AimArea1Name);
   unloadAimArea(AimArea2Name);
   unloadAimArea(AimArea3Name);
   unloadAimArea(AimArea4Name);
   unloadAimArea(AimArea5Name);
   unloadAimArea(AimArea6Name);
   
   
   return(0);
}
   
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

int init()
{
   
    deinit();
    AimPriceModeBkp = AimPriceMode;

    AimArea1Name = "AimArea1: " + AimArea1 + " Pips from " + sPriceMode;
    AimArea2Name = "AimArea2: " + AimArea2 + " Pips from " + sPriceMode;
    AimArea3Name = "AimArea3: " + AimArea3 + " Pips from " + sPriceMode;
    AimArea4Name = "AimArea4: " + AimArea4 + " Pips from " + sPriceMode;
    AimArea5Name = "AimArea5: " + AimArea5 + " Pips from " + sPriceMode;
    AimArea6Name = "AimArea6: " + AimArea6 + " Pips from " + sPriceMode;
}

  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
  
   _Point = Point;
   if (Is5DigitBroker) _Point = _Point*10;

   if(AimPriceMode!= AimPriceModeBkp) {
      Alert("aaa");
      init();
   }
   
   if(AimPriceMode==1) {
      priceMode = Bid;
      sPriceMode="Bid";
   }
   if(AimPriceMode==2) {
      priceMode=Ask; 
      sPriceMode="Ask"; 
   }
   if(AimPriceMode==3) {
      priceMode=(Bid + Ask)/2;
      sPriceMode="MidSpread"; 
   }
   
   int bartime = Time[1]-Time[0];

   int h,m,s,bigm,t;
   string TimeStr,H,M,S,Bigm;
   
   t = Time[0]+Period()*60-CurTime();
   
   s = t % 60;
   bigm = t / 60;
   h = bigm / 60;
   m = bigm - h * 60;
   
   S=s;
   if(StringLen(S)<2) S="0"+S;
   
   H=h;
   if(StringLen(H)<2) H="0"+H;

   M=m;
   if(StringLen(M)<2) M="0"+M;

   Bigm=bigm;
   if(StringLen(Bigm)<2) Bigm="0"+Bigm;
   
   if (ShowBarTimeHour && Period() > 60)
   {
     TimeStr = H + ":" + M + ":" + S;
     Comment(H + " hours " + M + " minutes " + S + " seconds left to bar end");
   }
   else
   {
     TimeStr = Bigm + ":" + S;
     Comment(Bigm + " minutes " + S + " seconds left to bar end");
   }
   
   if (ShowAimBarTime)
   {
     if(ObjectFind("BarTime") != 0)
     {
       ObjectCreate("BarTime", OBJ_TEXT, 0, Time[0], Close[0]);
     } 

     ObjectSetText("BarTime", AimBarTimeText+TimeStr, 9, "Courier New", BarTimeColor);
     ObjectMove("BarTime", 0, Time[0]-bartime*(AimBarTimeH_Pos), Bid + AimBarTimeV_Pos * _Point);
   }

   
   controlAimArea(AimArea1Name, AimArea1, AimArea1Color,AimBarH_Pos,AimPriceMode);
   controlAimArea(AimArea2Name, AimArea2, AimArea2Color,AimBarH_Pos,AimPriceMode);
   controlAimArea(AimArea3Name, AimArea3, AimArea3Color,AimBarH_Pos,AimPriceMode);
   controlAimArea(AimArea4Name, AimArea4, AimArea4Color,AimBarH_Pos,AimPriceMode);
   controlAimArea(AimArea5Name, AimArea5, AimArea5Color,AimBarH_Pos,AimPriceMode);
   controlAimArea(AimArea6Name, AimArea6, AimArea6Color,AimBarH_Pos,AimPriceMode);


   if (ShowWindowBarTime)
   {
     if (ObjectFind("TimeLabel") != 0)
     {
       ObjectCreate("TimeLabel", OBJ_LABEL, 0, 0,0);
     }
     
     ObjectSetText("TimeLabel", TimeStr, 9, "Arial", BarTimeColor);
     ObjectSet("TimeLabel", OBJPROP_XDISTANCE, 20);
     ObjectSet("TimeLabel", OBJPROP_YDISTANCE, 20);
     ObjectSet("TimeLabel", OBJPROP_CORNER, 1);
   }
   
   return(0);
  }
//+------------------------------------------------------------------+

void unloadAimArea(string AreaName) {
      ObjectDelete(AreaName);
      ObjectDelete( AreaName+" UP");
      ObjectDelete( AreaName+" DN");
      ObjectDelete( AreaName+" PUP");
      ObjectDelete( AreaName+" PDN");
      ObjectDelete( AreaName+" LU");
      ObjectDelete( AreaName+" LD");
     
}


void controlAimArea(string AreaName, int AreaPips, color AreaColor, int AimBarH_Pos=4, int AimPriceMode=1) {
 
   if (AreaPips<1) {
      unloadAimArea(AreaName);
      return (0);
   }
   
   
   int bartime = Time[1]-Time[0];

      datetime recRight =  Time[0] - bartime*AimBarH_Pos;
      datetime recLeft  =  recRight - bartime;
      double recTop     =  priceMode + AreaPips * _Point;
      double recBottom  =  priceMode - AreaPips * _Point;
      
      /*
      datetime recRightB =  recRightT;
      datetime recLeftB  =  recLeftT;
      double   recTopB     =  recBottom  + AimTickerWidth/2 * _Point;
      double   recBottomB  =  recBottom  - AimTickerWidth/2 * _Point;
      */
      


      if(ObjectFind(AreaName) != 0) {
         ObjectCreate(AreaName, OBJ_RECTANGLE, 0,recLeft, recTop, recRight,recBottom  );
         ObjectSet(AreaName, OBJPROP_COLOR, AreaColor);
      }  else  {

         ObjectSet(AreaName, OBJPROP_TIME1,  recLeft);
         ObjectSet(AreaName, OBJPROP_PRICE1, recTop);
         ObjectSet(AreaName, OBJPROP_TIME2,  recRight);
         ObjectSet(AreaName, OBJPROP_PRICE2, recBottom);
         
      }
     
     string tickerSignal="";
     if(ShowTickerLabel){
         string tickerText=AreaName+" LU";
         if(ObjectFind(tickerText) != 0)
         {
           ObjectCreate(tickerText, OBJ_TEXT, 0, Time[0], Close[0]);
         } else { 
          if(ShowTickerSignal) tickerSignal = " +";
          ObjectSetText(tickerText, tickerSignal+AreaPips, 6, "Arial", AimTickerColor);
          ObjectMove(tickerText, 0, recLeft-bartime*AimTickerLabelH_Pos, recTop+AimTickerLabelV_Pos*_Point);
         }

         tickerText=AreaName+" LD";
         if(ObjectFind(tickerText) != 0)
         {
           ObjectCreate(tickerText, OBJ_TEXT, 0, Time[0], Close[0]);
         } else { 
          if(ShowTickerSignal) tickerSignal = " -";
          ObjectSetText(tickerText, tickerSignal+AreaPips, 6, "Arial", AimTickerColor);
          ObjectMove(tickerText, 0, recLeft-bartime*AimTickerLabelH_Pos, recBottom+AimTickerLabelV_Pos*_Point);
         }
     }
          


     if(ShowTickerPrice){
         string TickerNamePUP = AreaName+" PUP";
         if(ObjectFind(TickerNamePUP) != 0)     {
            ObjectCreate(TickerNamePUP, OBJ_ARROW, 0,recLeft+bartime, recTop);
            ObjectSet(TickerNamePUP, OBJPROP_COLOR, AimTickerColor);
         } else {
            ObjectSet(TickerNamePUP, OBJPROP_ARROWCODE, 6);
            ObjectSet(TickerNamePUP, OBJPROP_WIDTH, 1);

            ObjectSet(TickerNamePUP, OBJPROP_TIME1,  recLeft+bartime*1);
            ObjectSet(TickerNamePUP, OBJPROP_PRICE1, recTop);
         }
      
         string TickerNamePDN = AreaName+" PDN";
         if(ObjectFind(TickerNamePDN) != 0)     {
            ObjectCreate(TickerNamePDN, OBJ_ARROW, 0,recLeft+bartime, recBottom);
            ObjectSet(TickerNamePDN, OBJPROP_COLOR, AimTickerColor);
         } else {
            ObjectSet(TickerNamePDN, OBJPROP_ARROWCODE, 6);
            ObjectSet(TickerNamePDN, OBJPROP_WIDTH, 1);

            ObjectSet(TickerNamePDN, OBJPROP_TIME1,  recLeft+bartime*1);
            ObjectSet(TickerNamePDN, OBJPROP_PRICE1, recBottom);
         }
      }

     

      string TickerNameUP = AreaName+" UP";
      if(ObjectFind(TickerNameUP) != 0)     {
         ObjectCreate(TickerNameUP, OBJ_ARROW, 0,recLeft+bartime, recTop);
         ObjectSet(TickerNameUP, OBJPROP_COLOR, AimTickerColor);
      } else {
         ObjectSet(TickerNameUP, OBJPROP_ARROWCODE, AimTickerSymbol);
         ObjectSet(TickerNameUP, OBJPROP_WIDTH, 1);

         ObjectSet(TickerNameUP, OBJPROP_TIME1,  recLeft+bartime);
         ObjectSet(TickerNameUP, OBJPROP_PRICE1, recTop);
      }
      
      string TickerNameDN = AreaName+" DN";
      if(ObjectFind(TickerNameDN) != 0)     {
         ObjectCreate(TickerNameDN, OBJ_ARROW, 0,recLeft+bartime, recBottom);
         ObjectSet(TickerNameDN, OBJPROP_COLOR, AimTickerColor);
      } else {
         ObjectSet(TickerNameDN, OBJPROP_ARROWCODE, AimTickerSymbol);
         ObjectSet(TickerNameDN, OBJPROP_WIDTH, 1);

         ObjectSet(TickerNameDN, OBJPROP_TIME1,  recLeft+bartime);
         ObjectSet(TickerNameDN, OBJPROP_PRICE1, recBottom);
      }

}

